# Generated by Django 4.2 on 2024-03-04 17:00

import apps.profiles.models
import apps.profiles.usermanager
from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import django.utils.timezone


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('auth', '0012_alter_user_first_name_max_length'),
    ]

    operations = [
        migrations.CreateModel(
            name='User',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('password', models.CharField(max_length=128, verbose_name='password')),
                ('last_login', models.DateTimeField(blank=True, null=True, verbose_name='last login')),
                ('is_superuser', models.BooleanField(default=False, help_text='Designates that this user has all permissions without explicitly assigning them.', verbose_name='superuser status')),
                ('username', models.CharField(help_text='Required. 32 characters or fewer. Letters, digits and @/./+/-/_ only.', max_length=32, verbose_name='username')),
                ('email', models.EmailField(blank=True, max_length=254, null=True, unique=True, verbose_name='email address')),
                ('is_staff', models.BooleanField(default=False, help_text='Designates whether the user can log into this admin site.', verbose_name='staff status')),
                ('is_active', models.BooleanField(default=True, help_text='Designates whether this user should be treated as active. Unselect this instead of deleting accounts.', verbose_name='active')),
                ('date_joined', models.DateTimeField(default=django.utils.timezone.now, verbose_name='date joined')),
                ('groups', models.ManyToManyField(blank=True, help_text='The groups this user belongs to. A user will get all permissions granted to each of their groups.', related_name='user_set', related_query_name='user', to='auth.group', verbose_name='groups')),
                ('user_permissions', models.ManyToManyField(blank=True, help_text='Specific permissions for this user.', related_name='user_set', related_query_name='user', to='auth.permission', verbose_name='user permissions')),
            ],
            options={
                'verbose_name': 'пользователя',
                'verbose_name_plural': 'users',
            },
            managers=[
                ('objects', apps.profiles.usermanager.CustomUserManager()),
            ],
        ),
        migrations.CreateModel(
            name='Rank',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('title', models.CharField(max_length=64, verbose_name='Название ранга')),
                ('title_ru', models.CharField(max_length=64, null=True, verbose_name='Название ранга')),
                ('title_ky', models.CharField(max_length=64, null=True, verbose_name='Название ранга')),
                ('point_required', models.PositiveIntegerField(unique=True, verbose_name='Необходимые баллы к общему количеству')),
                ('order', models.PositiveIntegerField(blank=True, default=apps.profiles.models.get_ordinal_order, verbose_name='Порядковый номер ранга')),
                ('cumulative_sum', models.PositiveIntegerField(default=0, verbose_name='Общее количество баллов')),
            ],
            options={
                'verbose_name': 'ранг',
                'verbose_name_plural': 'Добавление рангов',
            },
        ),
        migrations.CreateModel(
            name='Profile',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('image', models.ImageField(blank=True, default=apps.profiles.models.set_random_photo, null=True, upload_to='profile/profile_pics')),
                ('completed_lesson', models.PositiveIntegerField(default=0, verbose_name='Завершенные уроки')),
                ('completed_test', models.PositiveIntegerField(default=0, verbose_name='Завершенные тесты')),
                ('total_points', models.PositiveIntegerField(default=0, verbose_name='Баллы')),
                ('point_count', models.PositiveIntegerField(default=0, verbose_name='Счетчик баллов для профиля')),
                ('rank', models.ForeignKey(blank=True, default=apps.profiles.models.get_first_default_rank, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='users_rank', to='profiles.rank', verbose_name='Ранг')),
                ('user', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, related_name='profile', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'профиль',
                'verbose_name_plural': 'Профили пользователей',
            },
        ),
    ]
